/******************************************************************************
*******************************************************************************
****	Copyright (c) 1997, 1998, 1999, 2000, 2001
****	Conexant Systems Inc. (formerly Rockwell Semiconductor Systems)
****	Personal Computing Division
****	All Rights Reserved
****
****	CONFIDENTIAL and PROPRIETARY --
****		No Dissemination or use without prior written permission.
****
*******************************************************************************
**
**MODULE NAME:
**	????
**
**FILE NAME:
**	CnxLoad.c
**
**ABSTRACT:
**	This file implements the download application for the Tigris ADSL
**	device.  It will open and read the hex record file, process the
**	record into binary data and then send them to the driver for
**	execution.
**
**DETAILS:
**	????
**
*******************************************************************************
** KEYWORDS:
**	$Archive: /Projects/Tigris and Derivatives Linux/Reference Designs/Tigris/Linux 2.4 ATM Driver/DownLoadApp/cnxadslstatus.c $
**	$Revision: 1 $
**	$Date: 3/29/01 8:24a $
*******************************************************************************
******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <getopt.h>
#include <wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/time.h>

#include <atm.h>

#include "../LnxDefs.h"
#include "../CommonData.h"
#include "../ConfigLabels.h"

static struct atmif_sioc Socketioc;

int main(int argc,char **argv)
{
  int Status;
  int SocketID;
  ULONG				ShowTimeFlag;
  int				c;
  int				h_opt = 0;
  int				opt_err = 0;

  while ((c = getopt(argc,argv,"hi:")) != EOF) {
    switch (c) {
    case 'h' :
      h_opt |= 1;
      opt_err |= 1;
      break;
    case 'i' :
      Socketioc.number = atoi(optarg);
      break;
    default :
      opt_err |= 1;
      break;
    }
  }

  if (opt_err || ((argc - optind) != 0)) {
    printf("Usage: cnxadslstatus [-h][-i itf]\n");
    if (h_opt)
      printf("-h     help\n"
       "-i itf atm interface number\n");
    exit(1);
  }

  SocketID = socket(PF_ATMPVC, SOCK_DGRAM, 0);
  if (SocketID < 0)
  {
    printf("Socket open failure\n");
    return STATUS_FAILURE;
  }

  // get the showtime status
  Socketioc.arg    = &ShowTimeFlag;
  Socketioc.length = sizeof(ShowTimeFlag);

  Status = ioctl(SocketID, TIG_IS_SHOWTIME, &Socketioc);
  if (Status < 0)
    perror("");
  else {
    if (!ShowTimeFlag)
      printf("NO Showtime!\n");
    else
      printf("Showtime.\n");
  }

  close(SocketID);

  return 0;
}
