/******************************************************************************
*******************************************************************************
****	Copyright (c) 1997, 1998, 1999, 2000, 2001
****	Conexant Systems Inc. (formerly Rockwell Semiconductor Systems)
****	Personal Computing Division
****	All Rights Reserved
****
****	CONFIDENTIAL and PROPRIETARY --
****		No Dissemination or use without prior written permission.
****
*******************************************************************************
**
**MODULE NAME:
**	CardAL
**
**FILE NAME:
**	CardALTigrisDp.h
**
**ABSTRACT:
**	CardALTigris Data Pump interface Header File
**
**DETAILS:
**
*******************************************************************************
** KEYWORDS:
**	$Archive: /Projects/Tigris and Derivatives Linux/Reference Designs/Yukon-AV/Linux_2.4_ATM_Driver/KernelModule/CardALTigrisDp.h $
**	$Revision: 8 $
**	$Date: 7/05/01 9:47p $
*******************************************************************************
******************************************************************************/

#ifndef _CARDALTIGRISDP_H	// File Wrapper
#define	_CARDALTIGRISDP_H

#include "types.h"
#include "CardMgmt.h"
#include "CardALTigrisHalV.h"
#include "CardALTigrisV.h"
#include "dpcontrollerV1.h"
#include "xcvrinfo.h"
#include "sysinfo.h"

#ifndef _DATAPUMP_H_
	#define _DATAPUMP_H_
	typedef struct DATAPUMP_CONTEXT * PDATAPUMP_CONTEXT;
#endif

#define V2 1

#if V1
void InitDatapumpStructureV1
(
 IN PDATAPUMP_CONTEXT pDatapump,
 IN void * pExternalContext
);
#define InitDatapumpStructureV2 InitDatapumpStructureV1
#else
#define InitDatapumpStructureV2 InitDatapumpStructure
#endif

/******************************************************************************
Function Prototypes - Called from Pairgain Data Pump Controller
******************************************************************************/

#if V2
TICK_TYPE ChipAlTigrisDpGetCurrentTickV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

void ChipAlTigrisDpWaitQedferV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN WORD			Flags,
 IN WORD			Resolution,
 IN WORD			Timeout
);

void ChipAlTigrisDpSignalQedferV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN WORD			Flags
);
#endif

void ChipAlTigrisDPIndicateLinkUp
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

void ChipAlTigrisDPIndicateLinkDown
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR BOOLEAN ChipAlTigrisDpTestAndSet
(
 IN volatile LOCK_TYPE		* x
);

#if V2
MODULAR VOID ChipAlTigrisDpAtomicStartV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpAtomicEndV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpSITrapV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpIsrStartV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpIsrEndV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpIsrEndV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);
#endif

MODULAR VOID ChipAlTigrisDpDelayMsec
( 
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 DWORD				  duration 
);

#if V2
MODULAR VOID ChipAlTigrisDpGetNonVolatileParmsV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN XCVR_OTHER_CFG_TYPE		* pXcvr
);

MODULAR VOID ChipAlTigrisDpDisableIRQ1_2V2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpEnableIRQ1_2V2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpSetRstXcvrV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetGpioV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BYTE			Pin,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetAFEHybridSelectV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN UINT8			Select_Line,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetPwrDwnXcvrV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpWriteAFEV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BYTE			Address,
 IN BYTE			Data
);

MODULAR VOID ChipAlTigrisDpPendingReadAFEV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BYTE			Address
);

MODULAR BYTE ChipAlTigrisDpReadAFEV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR BOOLEAN ChipAlTigrisDpIsAFEDoneV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

GLOBAL BOOLEAN ChipAlTigrisDpSwitchHookStateEnqV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpTraceWriteV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN BYTE			Offset,
 IN DWORD			Value
);

GLOBAL UINT16 ChipAlTigrisDpGetVendorIdV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoWiringV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoHandshakeV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoSenseWiresFirstV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

void ChipAlTigrisDpWaitQedferV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 IN WORD			Flags,
 IN WORD			Resolution,
 IN WORD			Timeout
);

GLOBAL void ChipAlTigrisDpSetWiringV2
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS,
 BOOLEAN			Automatic,
 SYS_WIRING_SELECTION_TYPE	WiringSelection
);
#endif

/* Called from ? */

GLOBAL void ChipAlTigrisDpSER_InitMsgQ
(
 IN CDSL_ADAPTER_T		* pThisAdapter
);

GLOBAL void ChipAlTigrisDpTRM_TerminalInit
(
 IN CDSL_ADAPTER_T		* pThisAdapter
);

GLOBAL void ChipAlTigrisDpSER_DetectTerminalConnected
(
 IN CDSL_ADAPTER_T		* pThisAdapter
);

GLOBAL void ChipAlTigrisDpTRM_AutoUpdateDisable
(
 IN CDSL_ADAPTER_T		* pThisAdapter,
 SYS_LOGON_MODE_TYPE		mode,
 BOOLEAN			disable
);

GLOBAL void ChipAlTigrisDpSER_ClearRemoteLogon
(
 IN CDSL_ADAPTER_T		* pThisAdapter
);

GLOBAL void ChipAlTigrisDpSER_RcvIntrHandler
(
 IN CDSL_ADAPTER_T		* pThisAdapter,
 IN char			input_char
);
#endif	// File Wrapper
